
Version 1.0.0(Jan 30th, 2021)
 - The GUI can be used to download any media supported by youtube-dl.
 - The GUI can show all available media a url can offer.
 - The GUI allows user to choose what media entry offered by a url they want to download.
 - The GUI offers a preset list of options to choose from to select what media entry
    offered by a url they want to download.
 - The GUI offers an ability to change preset options or add new ones making it possible
    to use the GUI to automate any use case supported by youtube-dl.
 - The GUI offers an ability to download single media or multiple medias in batches.
 - Works on Linux and Windows.

Version 1.1.0(March 1st, 2021)
[All]
 - Add polish translations.

[Linux]
 - Add support for downloading media using wget in addition to youtube-dl.

[Windows]
 - Add ability to automatically download youtube-dl binary on first run and a button
    in the configuration tab to update it on demand.
 - The "Cancel" button now works as expected.

Version 1.2.0(April 1st, 2021)
[All]
 - Add json based plugin system to make it possible for users to use their preffered
   backends to download media.

[Windows]
 - Bundle ffmpeg.

 Version 1.3.0(May 1st, 2021)
 [All]
 - Add simplified chinese translations.
 - Add Spanish translations.
 - Add an option to do batch downloads concurrently.
 [Windows]
 - Add a portable version(A self contained version that keeps everything in the application folder).
 [Linux]
 - Add an option to prefer system executables over private media downloader executables.

  Version 1.4.0(June 1st, 2021)
 [All]
- Add dark themes support.
- Add Turkish translations.
- Update translations.
- Make each tab control its own default engine.
- Add a tab in a configure tab that allow changing of default downloading options for each engine.
- Add a library tab that allows management of downloaded media from within the app.
- Make it possible to launch a media by double clicking its entry in the batch tab,playlist tab and library tab.
- Add support for gallery-dl extension(https://github.com/mikf/gallery-dl).
 [Windows]
- Update bundled OpenSSL to version 1.1.1j.

  Version 1.5.0(July 1st, 2021)
  [All]
- Show thumbnails in the playlist downloader tab and in the batch downloader tab. An option has to be set in the
  configure tab to enable thumbnails to show up in the batch downloader tab because  fetching thumbnails
  is a slow process.
- Make it possible to start downloading or cancel an ongoing download at an individual entry in the batch downloader
  or playlist downloader tab.
- Make it possible to set downloading option per entry in the batch downloader or playlist downloader that overrides
  global options that are set in the "Enter Options" field.

  Version 1.6.0(August 4th, 2021)
    [All]
  - Add a context menu in the batch downloader tab and playlist downloader tab to save add added entries to disk.
  - Show progress in the title bar when downloading media through the batch downloader tab and playlist downloader tab.
  - Add "--max-media-length" and "--min-media-length" options to exclude playlist entries that falls outside the media lenght boundary.
  - Update translations.
  - Add ability to show history of receantly used commands in all relevant places.

  Version 1.7.0(October 2nd, 2021)
    [All]
  - Switch default engine from youtube-dl to yt-dlp.
  - Add "--break-on-existing" playlist downloader option to stop processing playlist when the id of a current entry is found in the
    archive file. This option goes in the "Get List Options" text field in the playlist downloader tab.
  - Add "--skip-on-existing" playlist downloader option to show in the UI a playlist's current entry when its id is in the archive file
    but not downloading its media. This option goes in the "Get List Options" text field in the playlist downloader tab.
  - Add a checkbox in the playlist downloader tab to save entered playlist for processing.
  - Above three options in combination with manual setting of archive file option
    (configure tab->engine default option tab->"default download options" text field  makes it possible to
    easily monitor and download new entries in playlists.

  Version 1.8.0(October 12nd, 2021)
    [Windows]
  - Bundle "aria2c" binary.
  - Bundle "aria2c" extension.
    [All]
  - Add support for "yt-dlp-aria2c" extension that causes yt-dlp extension to use aria2c as its downloader.
  - Add support for "aria2c" extension.
  - Add Russian translations.

  Version 1.9.0(October 17th, 2021)
    [All]
    - Add Japanese translations,

  Version 2.0.0(Novermber 3rd, 2021)
    [All]
    - Add "-u" commnd line option to add a Url to the application's batch downloder tab. This feature is useful when used
    with browser extensions that can open links in external application and it can be used to quickly add a link to the application.
    - Add "-a" commnd line option to automatically start downloading Url added with "-u" option.

  Version 2.1.0(December 1st, 2021)
    - Add ability to set what engine should be used and with what options based on entered url. This ability allows for
      example to say "i want yt-dlp to be used with download option of "mp4-mobile" with any link from streamable.com".
    - Add ability to bookmark channels in the playlist downloader tab to make it easier to monitor favorite channels.

  Version 2.1.1(December 2st, 2021)
    - Fix a bug caused by a change in yt-dlp output.

  Version 2.2.0(January 1st, 2022)
    - Add French translations.
    - Add ability to show and save comments in batch downloader tab and playlist downloader tab.
    - Automatically add clipboard contents to the active tab if it contains url. Off by default for now and
      look for option "MonitorClipboardContents" in the app's config file set it to true to enable it.
    - Various changes and improvements.

  Version 2.2.1(March 3rd, 2022)
    - Make it possible to customize fusion dark theme by saving theme options in a config file.
    - Add ability to show in the UI available media subtitles and to download them or embed them in downloaded file.
    - Add an option to auto save not downloaded media on exit.

 Version 2.3.0(May 1st, 2022)
    - Add lux backend. Project page is at: https://github.com/iawia002/lux
    - Update language translations.
    - Add a checkbox in batch downloader tab to make it easy to enable/disable monitoring of clipboard for Url.

 Version 2.4.0(July 1st, 2022)
    - Add svtplay-dl extension. Project page is at: https://github.com/spaam/svtplay-dl
    - Add you-get extension. Project page is at: https://github.com/soimort/you-get
    - Add Italian translations.

  Version 2.5.0(August 1st, 2022)
    [Windows]
    - Bundle python 3.8.10.
    - Replace bundled 7zip with bsdtar.
    [All]
    - Add Swedish language.
    - Update other langauge translations.
    - Add a button in the configure tab to make it easy to reach a folder where binaries are located.
    - Automatically download and manage folder based you-get executable.

  Version 2.6.0(October 1st, 2022)
    [Windows]
    - Bundle wget 1.21.3.
    [All]
    - Add GUI options in playlist downloader tab to enable/disable internal archive file and to clear it.
    - Fix a bug that prevented downloading of urls from a file if the file use "\r\n" as line separator.
    - Add ability to have multiple profiles for downloading options.

  Version 2.7.0(Novermber 10th, 2022)
    [All]
    - Add German translations.
    - Add a GUI option to check for Media Downloader update on startup.
    - Add a GUI option to download a section of a media in batch downloader tab.
    - Update other langauge translations.

  Version 2.8.0(January 3rd,2023)
    [All]
    - Download all missing executables on startup if they are not present for some reason.
    - Also check updates for extensions when "check for updates" option is set. This option previously checked
      for Media Downloader updates only,
    - Check for extensions update and automatically download them if newer version are found when both
      "Show Version Info When Starting" and "check for updates" options are set.
    - Cancelling a download now also terminates ffmpeg or aria2c if they were started by the download.

  Version 2.9.0(March 2nd, 2023)
      [All]
    - Add Portuguese(Brazilian) translations.
    - Make entry table in the playlist tab larger after it is populated.
    - Required minimum version of yt-dlp is 2023.01.06.
    - Its now possible to cancel populating library tab.

  Version 3.0.0(April 1st, 2023)
      [Windows]
    - It is now possible for the app to update itself.
      [All]
    - yt-dlp now works as expected and it shows downloading media size instead of "NA".

  Version 3.1.0(April 4st, 2023)
      [All]
      - Add Dutch(Netherlands) translations.
      - Fix a bug that was caused by lux backend changing names of its binaries.

  Version 3.2.0(June 25th, 2023)
      [All]
      - Update to make it compatible with yt-dlp version 2023.06.22.

  Version 3.2.1(June 30th, 2023)
      [All]
      - Only show yt-dlp output we care about in the log window.
      [Non Windows]
      - Do not auto update media downloader because it works for windows only.

  Version 3.3.0(August 1st, 2023)
  [Windows]
      - Fix a problem that caused installed version to keep on updating updated version of Media Downloader and other engines.
      [All]
      - Update Chinese translations.
      - Update Russian translations.
      - Fix problems in basic downloader tab.
      - Various changes and improvements.

  Version 3.4.0(October 1st, 2023)
      [All]
      - Add a config option to auto hide downloaded entries in batch and playlist downloader tabs.
      - Add a "proxy" sub tab in a configure tab to set proxy settings.
      - Default to h264 video codec instead of yt-dlp's vp9 when downloading youtute videos.
      - Update Italian translations.

  Version 4.0.0(Novermber 2nd, 2023)
      [Windows]
      - Update bundled version of ffmpeg to version 6.0.
      - Fix a problem that caused the UI to hang when reading clipboard data.
      - App title bar is now black when using dark theme.
      [All]
      - Respect an option to save not downloaded entries when the apps quits unexpectedly.

  Version 4.1.0(December 1st, 2023)
      [All]
      - Various changes and improvements.

  Version 4.2.0(January 2nd, 2024)
      [Windows]
      - Fix a bug that caused older version of ffmpeg to be used when user install newer version of MD
       that uses newer version of ffmpeg without first unistalling older version of MD that uses older
       version of ffmpeg.
      [All]
      - Add ability show entries in the library tab in various orders.
      - Add ability to filter and sort media list to easily choose which ones to download.
      - Rework UI options that control checking for updates and autodownloads at startup.

  Version 4.3.0(February 1st, 2024)
      [Windows]
      - Automatic updates of Media Downloader can now be configured to track git updates. Look for
        option named "WindowsUpdateChannel" in the config file and change its value to "git" to start
        monitoring git channel. Change the value back to "release" to go back to monitoring release channel.
      [All]
      - Fix a bug that causes a crash when trying to be clever with certain user provided yt-dlp options.

  Version 4.3.1(February 1st, 2024)
      - Hot fix release so just repeating changelong for version 4.3.0.
      [Windows]
      - Automatic updates of Media Downloader can now be configured to track git updates. Look for
        option named "WindowsUpdateChannel" in the config file and change its value to "git" to start
        monitoring git channel. Change the value back to "release" to go back to monitoring release channel.
      [All]
      - Fix a bug that causes a crash when trying to be clever with certain user provided yt-dlp options.

  Version 4.4.0(March 3rd, 2024)
      [Windows]
     - Fix a bug that caused Media Downloader to not show progress report when file names contained invalid
       json character.
      [All]
     - Add a boolean config only option named  "DeleteFilesOnCanceledDownload" to delete temporary files
        when download is cancelled.
     - Add a file size colum in "media options" table to easily show media file sizes.
     - Now buildable with Qt6. Pass "-DBUILD_WITH_QT6=TRUE" option to cmake to build for Qt6.

  Version 4.5.0(April 1st, 2024)
      [All]
     - Support internal downloading and updating svtplay.
     - "Show media Options" menu now has a context menu with a list of video players you can use for
        streaming a media instead of downloading it.
     - Its now possible to select random entries in batch and playlist downloader tabs and batch download
      only those selected.

     Version 4.6.0(May 3rd, 2024)
     [Windows]
     - Update bundled ffmpeg to version 7. Unistall first Media Downloader before updating to this version
       because some ffmpeg files are named differently causing older files to not be removed.
      [All]
     - Add config only for now options to show desktop notification when a download is complete. To get a
       desktop notification when a download is complete, add option
       "DesktopNotifyOnDownloadComplete=true" to the config file. To get a desktop notification when all
       downloads complete, add option "DesktopNotifyOnAllDownloadComplete" to the config file.
    - Add support for "--playlist-reverse" yt-dlp option. Media Downloader need to simulate yt-dlp playlist options
      because it manages the playlist itsef.

     Version 4.7.0(May 24, 2024)
      [All]
    - Add Arabic translations.
    - Add support for MacOS.

     Version 4.8.0(July 3rd, 2024)
         [All]
    - Add Korean translations.
    - Fix a bug that prevented you-get from getting auto updated caused by upstream change.
    - Add ability to edit in place engine's default options.
    - Add ability to sort comments by likes or date.

     Version 4.9.0(August 1st, 2024)
         [All]
    - Fix a bug in basic downloader tab that shows up with latest version of yt-dlp.
    - Add improvements to Lux backend.


     Version 5.0.0(August 16th, 2024)
         [Linux]
         - Add support for flatpak and a flatpak package is hosted at
           flathub(https://flathub.org/apps/io.github.mhogomchungu.media-downloader).
         [All]
         - Various bug fixes and improvements.

     Version 5.0.1(August 20th, 2024)
         [All]
         - Use blue icons when a dark theme is in use.
         [Flatpak]
         - Use ~/Downloads folder as default download folder.

     Version 5.1.0(September 5th, 2024)
         [All]
         - Add ability to rename downloaded media in the batch downloader tab.
         - Add ability to rename entries in the library tab.
         - Add ability to play downloaded media in the basic downloader tab.
         - Add ability to edit preset options.
         - Ask for confirmation before deleting entries in the library tab.
         - Fix a bug that caused Qt based external tools to be affected by the app's scalling factor.

     Version 5.2.0(November 4th, 2024)
         [Windows]
         - Use yt-dlp from "https://github.com/nicolaasjan/yt-dlp" when using windows7.
         [All]
        - Add a context menu in the batch downloader tab to hide/show UI controls to make visible more entries to be downloaded.
        - When application starts, put it on the screen where it was when it was last closed.

     Version 5.2.1(January 31st, 2025)
         [ALL]
        - Maintanance release.
         [Flatpak]
        - Update KDE runtime from version 6.7 to version 6.8.

     Version 5.2.2(February 8th, 2025)
         [ALL]
        - Many Urls can now be added in batch downloader's Url's text field without hanging the application.
        - Update Brazilian Portuguese translations.
         [Windows Qt6 build]
        - Checkbox in batch downloader tab to monitor for clipboard contents now works.

     Version 5.3.0(March 1st, 2025)
         [Windows]
        - File names in batch and playlist downloader show up correctly when they
           contain some non ascii characters.
         [ALL]
        - Add Greek translations.
        - Add a GUI way to set yt-dlp and gallery-dl option of "--cookies-from-browser".

     Version 5.3.1(Match 11th, 2025)
     [ALL]
        - Fix a crash when using gallery-dl
        - Add a menu in configure tab to install a short list of supported extensions.
        - Rearrage configure->general tab to make it friendly to translations.
        - Add a platform default theme and a light theme options.
        - Make it possible in the UI to choose between setting a browser name or setting a path to a cookie file.

     Version 5.3.2(Match 24th, 2025)
     [MAC]
        - Make gallery-dl work out of the box.
     [ALL]
        - BUG fix: Download progress on the title bar shows again when downloading from batch downloader tab.

     Version 5.3.3(May 21st, 2025)
     [ALL]
        - Playlist downloader tab now says why populating playlist was stopped when using "--break-on-existing".
        - Fix a bug on batch downloader tab that may lead to a crash when fetching metadata.

     Version 5.4.0(May 29th, 2025)
     [ALL]
        - Fix a bug introduced in 5.3.3 that causes entries in batch downloader tab to start downloading when added because of using a wrong config only option.
        - Add an "Extension" sub tab in configure tab to expose more config only options in "General" sub tab.

     Version 5.4.1(July 11th, 2025)
     [Flatpak]
       - Make it possible to specifically call VLC to stream media(needs org.freedesktop.Flatpak permission).
     [WINDOWS]
       - Fix a bug caused by yt-dlp executable name change for 32 bit windows 7.
     [ALL]
       - Add Bulgarian translations.
       - EXPERIMENTAL support for Gallery-dl working in Playlist tab.
       - Add ability to show thumbnails in batch downloader tab when using gallery-dl.
       - It is now possible to start downloading while the playlist tab is getting filled with entries.
       - It is now possible to do simultaneous downloading from all three tabs that can do downloading.
       - It is now possible to send multiple urls to VLC for streaming. This is useful for example
         when you want to stream a media that is made up of a video only stream and an audio only stream.

     Version 5.4.2(August 1st, 2025)
     [ALL]
       - Maintanance release that fixes various issues.

     Version 5.4.3(October 1st, 2025)
     [WINDOWS]
       - Update ffmpeg to version 8.0.
     [ALL]
       - Add Ukranian translations.
       - Various fixes and improvements.

     Version 5.4.4(November 12th, 2025)
     [ALL]
       - Add support for autodownloading deno javascript runtime.

     Version 5.4.5(November 15th, 2025)
     [ALL]
       - Various fixes and improvements.
     [WINDOWS]
       - Default to quickjs javascript runtime on windows7 because deno does not work in windows7.
     [Flatpak]
       - Default to quickjs javascript runtime because deno crashes.
     [Linux and MacOS]
       - Default to bsdtar and fall back to unzip when unzipping .zip files.

     Version 5.4.6(November 17th, 2025)
     [ALL]
      - Update French translations.
      - Update Greek translations.
     [Flatpak]
      - Fix a bug that cause yt-dlp specific options to be set when using other engines.
     [Gallery-dl]
      - Fix a bug that caused downloaded files to be under "directlink" subfolder under certain circumstances.

     Version 5.4.7(January 13th, 2026)
     [ALL]
      - Maintanance Release.

     Version 5.4.8(January 21th, 2026)
     [ALL]
      - Update Chinese translations.
     [WINDOWS7]
      - Fix a bug that caused a wrong yt-dlp binary to be downloaded and used.

     Version 5.4.9(March 6th, 2026)
     [ALL]
      - Add Ui option to disable deno auto updating.
      - Add a Ui way to change Ui scale factor.
      - Workout a bug in deno 2.7.0 that prevented MD from updating it.

     Version 5.5.0(March 14th, 2026)
     [FLATPAK]
      - Bundle svtplay-dl because its dependencies are now bundled too.
     [ALL]
      - Show more info in batch downloader when using svtplay-dl.

     Version 5.5.1(April 14th, 2026)
     [FLATPAK]
      - Continue to bundle svtplay-dl dependencies but unbundle svtplay-dl executable.
     [ALL]
      - Add GUI options to tell MD to use system binaries or to download its own binaries.

     Version 5.5.2(April 23rd, 2026)
     [ALL]
      - Fix a bug that made it impossible to update Deno from within the application.
      - When showing a list of available media, show audio language below format code if it is available.

     Version 5.6.0(April 30th, 2026)
     [ALL]
      - Fix galley-dl update bug caused by upstream change of repository url.

      Version 5.6.1(May 18th, 2026)
     [WINDOWS]
      - Bundle wget2 in Qt6 build.
     [ALL]
      - Add "yt-dlp-nightly" extension to make it possible to use yt-dlp nightly version.
      - Improve support for wget2.

      Version 5.6.2(June 1st, 2026)
     [WINDOWS 7]
      - Use quickjs-ng instead of quickjs as yt-dlp javascript runtime.
     [FLATPAK]
      - Use quickjs-ng instead of quickjs as yt-dlp javascript runtime.
     [ALL]
      - Add "MediaDownloaderAppDataPath" environment variable to make it
        possible to change the default location of application data folder.
      - Various changes and improvements.

      Version 5.6.3(June 18th, 2026)
     [WINDOWS 7]
      - Fix a bug that causes quickjs-ng to not be detected.
     [WINDOWS]
      - Show more info when showing download progress when updating MD.
     [MACOS]
      - Save new preset options as soon as user press "save" button.
